
#include <avr\io.h>	
#include "mcp.h"
#include <avr\interrupt.h>
#include <avr\io8515.h>
#include "mcp2515_can.h"


#define F_CPU		4000000
#define UART_BAUD_RATE	9600
#define LED			1
#define	DDR_CS		DDRB
#define	PORT_CS		PORTB
#define	DDR_SPI		DDRB
#define	PORT_SPI	PORTB
#define	SPI_CS		4
#define	SPI_MISO	6
#define	SPI_MOSI	5
#define	SPI_SCK		7
#define	PD2			2



// Prototypen
void avr_init(void);
void delay(uint16_t ms);
void uartInit (void);


int main(void)
{
	mcp2515_init();

	uartInit();

	DDRA	 |= (1<<LED);		// LED-Port auf Ausgang

	/* Eingang fr Interruptleitung des MCP2515 + Pullup aktivieren */
	DDRD &= ~(1<<PD2);
	PORTD |= (1<<PD2);

	PORTA |= (1<<LED);
	delay(20);
	PORTA &= ~(1<<LED);
		while(1)
		{

				if (bit_is_clear(PIND, 2))		// irgendwo ist eine Nachricht reingekommen
				{
							//LED on
							PORTA |= (1<<LED);
							delay(20);

					// Status auslesen
					uint8_t status = mcp2515_read_rx_status();

					if (bit_is_set(status,6))
					{
						// Nachricht in Puffer 0
							    uart_putc(0xF0);
								uart_putc(mcp2515_read_register(RXB0D0));
								uart_putc(mcp2515_read_register(RXB0D1));
								mcp2515_bit_modify( CANINTF, 0x01, 0x00 );

					}
					else if (bit_is_set(status,7))
					{
						// Nachricht in Puffer 1
							    uart_putc(0x0F);
							    uart_putc(mcp2515_read_register(RXB1D0));
								uart_putc(mcp2515_read_register(RXB1D1));
								mcp2515_bit_modify( CANINTF, 0x02, 0x00 );
					}
					else {
								uart_putc(0xAA);
								uart_putc(status);
								uart_putc(0xAA);
					}

							//LED off
							PORTA &= ~(1<<LED);



				}
		}

	return 0;
}


/*
ISR(INT0_vect)
{
			//LED on
			PORTB |= (1<<LED);

		
		    // Daten in den Puffer schreiben und damit senden
		    uart_putc(mcp2515_read_register(RXB0D0));
			uart_putc(mcp2515_read_register(RXB0D1));

			delay(50);

			//LED off
			PORTB &= ~(1<<LED);

}
*/

void avr_init(void)
{

	DDRA	 |= (1<<LED);		// LED-Port auf Ausgang

	/* Eingang fr Interruptleitung des MCP2515 + Pullup aktivieren */
	DDRD &= ~(1<<PD2);
	PORTD |= (1<<PD2);
	
	/* Externen Interrupt 0 aktivieren ( fallende Flanke ) */
//	MCUCR |= (1<<ISC01);
//	GIMSK |= (1<<INT0);
	// General Interrups enable
//	sei();
}





void uartInit (void)
{
    /* UART Control Register laden. Wir verwenden (noch)
       keine Interrupts. Vorerst wollen wir nur mal senden, also wird
       nur das Transmitter Enable Flag gesetzt. */
    UCR = (1 << TXEN);

    /* Baudrate einstellen */
	UBRR = (F_CPU / (UART_BAUD_RATE * 16L) - 1);

} /* end of UartInit */





